/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package statnimesic;

import java.awt.KeyEventDispatcher;
import java.awt.KeyboardFocusManager;
import java.net.URL;
import java.util.ResourceBundle;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;

/**
 *
 * @author krajskeOndrej
 */
public class FXMLDocumentController implements Initializable {

    static FXMLDocumentController lst;
    private Label label;
    @FXML
    private Canvas mainGameOutputCanvas;
    @FXML
    private Label lblID;
    @FXML
    private Label lblX;
    @FXML
    private Label lblY;
    @FXML
    private Label lblVX;
    @FXML
    private Label lblVY;
    @FXML
    private Label lblP;
    @FXML
    private Label lblL;
    @FXML
    private Label lblR;

    private Game game;

    private final int graphCoef = 3;
    private final int graphicFloor = 30;
    private final Image shipleft = new Image("file:left.png");
    private final Image shipright = new Image("file:right.png");
    private final Image shipup = new Image("file:up.png");
    private final Image ship = new Image("file:lnd.png");

    @FXML
    private TextField txtAdres;
    @FXML
    private Label lblResultOutput;

    @Override
    public void initialize(URL url, ResourceBundle rb) {
        // TODO
        lst = this;

    }

    @FXML
    private void btnStartAction(ActionEvent event) {
        lst = this;
        game = new Game(txtAdres.getText());
        game.startGame();
        txtAdres.setDisable(true);
        lblResultOutput.setText("");

    }

    @FXML
    private void btnStartAUTOAction(ActionEvent event) {

    }

    public void render() {
        actualLbls();
        renderCanvas();
    }

    protected void actualLbls() {
        lblID.setText(String.valueOf("ID: " + game.getDp().ID));
        lblX.setText(String.valueOf("X: " + game.getDp().X));
        lblY.setText(String.valueOf("Y: " + game.getDp().Y));
        lblVX.setText(String.valueOf("Vx: " + game.getDp().Vx));
        lblVY.setText(String.valueOf("Vy: " + game.getDp().Vy));
        lblP.setText(String.valueOf("Palivo: " + game.getDp().P));
        lblL.setText(String.valueOf("L: " + game.getDp().L));
        lblR.setText(String.valueOf("R: " + game.getDp().R));
    }

    private void renderCanvas() {

        GraphicsContext gc = mainGameOutputCanvas.getGraphicsContext2D();
        gc.clearRect(0, 0, mainGameOutputCanvas.getWidth(), mainGameOutputCanvas.getHeight());
        //motory:
        if (game.nahoru == 1 && game.getDp().P > 0) {
            gc.drawImage(shipup, game.getDp().X * graphCoef, -graphicFloor + 200 * graphCoef - game.getDp().Y * graphCoef, 20 * graphCoef, 20 * graphCoef);//loď
        }
        if (game.doleva == 1 && game.getDp().P > 0) {
            gc.drawImage(shipleft, game.getDp().X * graphCoef, -graphicFloor + 200 * graphCoef - game.getDp().Y * graphCoef, 20 * graphCoef, 20 * graphCoef);//loď
        }
        if (game.doprava == 1 && game.getDp().P > 0) {
            gc.drawImage(shipright, game.getDp().X * graphCoef, -graphicFloor + 200 * graphCoef - game.getDp().Y * graphCoef, 20 * graphCoef, 20 * graphCoef);//loď
        }
        gc.drawImage(ship, game.getDp().X * graphCoef, -graphicFloor + 200 * graphCoef - game.getDp().Y * graphCoef, 20 * graphCoef, 20 * graphCoef);//loď
        gc.fillRect(game.getDp().L * graphCoef, 200 * graphCoef, game.getDp().R * graphCoef, 8);//pristavani

        //palivo:
        gc.fillRect(mainGameOutputCanvas.getWidth() - 34, 0, 34, (game.getDp().P / game.getDp().palivoPuvodni) * 90);

    }

    private void keyAction(KeyEvent event) {
        if (game != null) {
            game.nahoru = (event.getCode() == KeyCode.UP || event.getCode() == KeyCode.W) ? 1 : 0;
            game.doleva = (event.getCode() == KeyCode.LEFT || event.getCode() == KeyCode.A) ? 1 : 0;
            game.doprava = (event.getCode() == KeyCode.RIGHT || event.getCode() == KeyCode.D) ? 1 : 0;
        }
    }

    @FXML
    private void keyActionPressed(KeyEvent event) {
        switch (event.getCode()) {
            case UP:
            case W:
                game.nahoru = 1;
                break;
            case LEFT:
            case A:
                game.doleva = 1;
                break;
            case RIGHT:
            case D:
                game.doprava = 1;
                break;
        }
    }

    @FXML
    private void keyActionReleased(KeyEvent event) {
        switch (event.getCode()) {
            case UP:
            case W:
                game.nahoru = 0;
                break;
            case LEFT:
            case A:
                game.doleva = 0;
                break;
            case RIGHT:
            case D:
                game.doprava = 0;
                break;
        }
    }

    public void setoutputLabel(String in) {
        lblResultOutput.setText(in);
    }

}
